" Shortcuts
map <C-o> :NERDTreeToggle<CR>
map <F8>  :TagbarToggle<CR>

" Required for operations modifying multiple buffers like rename.
set hidden

let g:LanguageClient_serverCommands = {
\ 'rust': ['rust-analyzer']
\ }


" Navigate Completion List
inoremap <silent><expr> <Tab>  pumvisible() ? "\<C-n>" : "\<Tab>"
inoremap <silent><expr> <S-Tab> pumvisible() ? "\<C-p>" : "\<S-Tab>"

" Confirm Selection
inoremap <expr> <cr> pumvisible() ? "\<C-y>" : "\<C-g>u\<CR>"

" LanguageClient Options 
nnoremap <F5> :call LanguageClient_contextMenu()<CR>

" Plugged Plugins
call plug#begin(stdpath('data') . '/plugged')

" Delimiter Autocompletion
Plug 'raimondi/delimitmate'

" One Dark Theme
Plug 'joshdick/onedark.vim'

" Monokai Theme
Plug 'tomasr/molokai'

" Tender Theme
Plug 'jacoborus/tender.vim'

" Not too sure if this extension is necessary tbh
Plug 'sheerun/vim-polyglot'

" Powerline Bar at bottom of screen
Plug 'itchyny/lightline.vim'

" Scope Tags
Plug 'majutsushi/tagbar'

" Syntax
Plug 'vim-syntastic/syntastic'

" Rust Support
Plug 'rust-lang/rust.vim'

" Language Server Protocol Support
Plug 'autozimu/LanguageClient-neovim', { 'branch': 'next', 'do': 'bash install.sh', }

" Autocomplete
Plug 'Shougo/deoplete.nvim', { 'do': ':UpdateRemotePlugins' }

" Fuzzy Search 
Plug 'junegunn/fzf'

" Multiple Cursors
Plug 'terryma/vim-multiple-cursors'

" File Browser
Plug 'preservim/nerdtree'

" NerdTree Icons (Should be last according to docs)
Plug 'ryanoasis/vim-devicons'

" Better Rust Synatax Highlighting 
Plug 'arzg/vim-rust-syntax-ext'

call plug#end()

" Autosave with rust-fmt (Rust Only)
let g:rustfmt_autosave = 1

" Enable Autocomplete
let g:deoplete#enable_at_startup = 1

" Install Tender for Lightline
let g:lightline = { 'colorscheme': 'molokai' }

" Let The LSP Client know which Language servers to use
let g:LanguageClient_serverCommands = {
\ 'rust': ['rust-analyzer']
\ }

" Configuration
set noshowmode " Not Needed because we have Lightline
colorscheme molokai 


